package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        if(this.size() == 0){ return true;}
        return false;
    }

    @Override
    public Cart get(User key) {
        // find the cart associate with the key
        Cart result = null;
        for (Entry e: entries){
            if(e.getKey().equals(key)){
                result = e.getValue();
            }
        }
        return result;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        Entry thing = new Entry(key, value);
        entries.add(thing);
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        List<User> keys = new ArrayList<>();
        for (Entry e: entries){
            keys.add(e.getKey());
        }
        return keys;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        List<Cart> values = new ArrayList<>();
        for (Entry e: entries){
            values.add(e.getValue());
        }
        return values;
    }

    @Override
    public Cart remove(User key) {
        Cart removed = null;
        for (Entry e: entries){
            if (e.getKey().equals(key)){
                entries.remove(e);
                removed = e.getValue();
                break;
            }
        }
        return removed;
    }
}
